## altos 1.6.5

=== doc/Makefile ===
#
#	http://docbook.sourceforge.net/release/xsl/current/README
#

RELNOTES_INC=\
	release-notes-1.6.5.inc \
	release-notes-1.6.4.inc \
	release-notes-1.6.3.inc \
	release-notes-1.6.2.inc \
	release-notes-1.6.1.inc \
	release-notes-1.6.inc \
	release-notes-1.5.inc \
	release-notes-1.4.2.inc \
	release-notes-1.4.1.inc \
	release-notes-1.4.inc \
	release-notes-1.3.2.inc \
	release-notes-1.3.1.inc \
	release-notes-1.3.inc \
	release-notes-1.2.1.inc \
	release-notes-1.2.inc \
	release-notes-1.1.1.inc \
	release-notes-1.1.inc \
	release-notes-1.0.1.inc \
	release-notes-0.9.2.inc \
	release-notes-0.9.inc \
	release-notes-0.8.inc \
	release-notes-0.7.1.inc

IMAGES=\
	altosui.png \
	ascent.png \
	configure-altimeter.png \
	configure-altosui.png \
	configure-groundstation.png \
	configure-pyro.png \
	descent.png \
	device-selection.png \
	easymega.svg \
	easymega-v1.0-bottom.jpg \
	easymega-v1.0-top.jpg \
	easymini.svg \
	easymini-top.jpg \
	fire-igniter.png \
	graph-configure.png \
	graph-map.png \
	graph.png \
	graph-stats.png \
	ignitor.png \
	landed.png \
	launch-pad.png \
	load-maps.png \
	micropeak-app.png \
	micropeak-back.jpg \
	micropeak-device-dialog.png \
	micropeak-dime.jpg \
	micropeak-download.png \
	micropeak-graph-configure.png \
	micropeak-graph.png \
	micropeak-nofont.svg \
	micropeak-preferences.png \
	micropeak-raw-data.png \
	micropeak-save-dialog.png \
	micropeak-statistics.png \
	MicroPeakUSB-2.0-inuse.jpg \
	MicroPeakUSB-2.0.jpg \
	monitor-idle.png \
	scan-channels.png \
	site-map.png \
	table.png \
	telegps-configure.png \
	telegps-graph-configure.png \
	telegps-graph-graph.png \
	telegps-graph-map.png \
	telegps-graph-stats.png \
	telegps-info.png \
	telegps-location.png \
	telegps-map.png \
	telegps-preferences.png \
	telegps-scan.png \
	telegps-status.png \
	telegps-table.png \
	telegps-v1.0-top.jpg \
	telemega.svg \
	telemega-v1.0-top.jpg \
	telemetrum.svg \
	telemetrum-v1.1-thside.jpg \
	telemetrum-v2.0-th.jpg \
	telemini.svg \
	telemini-v1-top.jpg \
	altusmetrum-oneline.svg \
	telegps-oneline.svg \
	micropeak-oneline.svg

TXT_FILES=altusmetrum.txt

COMMON_INC_FILES=\
	config-device.inc \
	config-ui.inc \
	load-maps.inc \
	aprs-operation.inc \
	handling.inc

INC_FILES=\
	dedication.inc \
	intro.inc \
	getting-started.inc \
	usage.inc \
	telemetrum.inc \
	telemini-v1.0.inc \
	easymini-device.inc \
	telemega.inc \
	easymega.inc \
	installation.inc \
	using-am-products.inc \
	updating-firmware.inc \
	altosui.inc \
	altosdroid.inc \
	system-operation.inc \
	pyro-channels.inc \
	flight-data-recording.inc \
	specs.inc \
	$(COMMON_INC_FILES) \
	release-notes.inc \
	$(RELNOTES_INC)

RAW_FILES=$(TXT_FILES:.txt=.raw) $(INC_FILES:.inc=.raw)

TELEGPS_INC_FILES=\
	telegps-dedication.inc \
	telegps-quick-start.inc \
	telegps-using.inc \
	telegps-system-operation.inc \
	telegps-application.inc \
	telegps-specs.inc \
	telegps-updating-firmware.inc \
	telegps-release-notes.inc \
	$(COMMON_INC_FILES)

TELEGPS_TXT_FILES=\
	telegps.txt

TELEGPS_RAW_FILES=$(TELEGPS_TXT_FILES:.txt=.raw) $(TELEGPS_INC_FILES:.inc=.raw)

MICROPEAK_TXT_FILES=\
	micropeak.txt

MICROPEAK_INC_FILES=

MICROPEAK_RAW_FILES=$(MICROPEAK_TXT_FILES:.txt=.raw) $(MICROPEAK_INC_FILES:.inc=.raw)

EASYMINI_TXT_FILES=\
	easymini.txt

EASYMINI_INC_FILES=$(INC_FILES) easymini-release-notes.inc


EASYMINI_RAW_FILES=$(EASYMINI_TXT_FILES:.txt=.raw) $(EASYMINI_INC_FILES:.inc=.raw)

OUTLINE_TXT_FILES=\
	easymega-outline.txt \
	easymini-outline.txt \
	telemega-outline.txt \
	telemetrum-outline.txt \
	telemini-outline.txt

OUTLINE_RAW_FILES=$(OUTLINE_TXT_FILES:.txt=.raw)

OUTLINE_PDF_FILES=$(OUTLINE_TXT_FILES:.txt=.pdf)

SVG=\
	easymini.svg \
	telemega.svg \
	telemetrum.svg \
	telemini.svg \
	easymega.svg

RELNOTES_PDF=$(RELNOTES_INC:.inc=.pdf)
RELNOTES_HTML=$(RELNOTES_INC:.inc=.html)

ONEFILE_TXT_FILES=\
	altos.txt \
	companion.txt \
	telemetry.txt

ONEFILE_RAW_FILES=$(ONEFILE_TXT_FILES:.txt=.raw)
ONEFILE_PDF_FILES=$(ONEFILE_TXT_FILES:.txt=.pdf)

AM_HTML=am.html

HTML=altusmetrum.html micropeak.html telegps.html easymini.html $(RELNOTES_HTML) $(ONEFILE_HTML_FILES)

HTML_REVHISTORY=\
	altusmetrum-revhistory.html \
	micropeak-revhistory.html \
	telegps-revhistory.html \
	easymini-revhistory.html

PDF=altusmetrum.pdf micropeak.pdf telegps.pdf easymini.pdf $(RELNOTES_PDF) $(ONEFILE_PDF_FILES) \
	$(OUTLINE_PDF_FILES)

FOP_STYLE=am-fo.xsl
HTML_STYLE=am-html.xsl
COMMON_STYLE=common.xsl
FOP_XCONF=fop.xconf
STYLESHEET=am.css

FONTS=\
	fonts/DejaVuSansMono-BoldOblique.ttf \
	fonts/DejaVuSansMono-Bold.ttf \
	fonts/DejaVuSansMono-Oblique.ttf \
	fonts/DejaVuSansMono.ttf \
	fonts/OpenSans-Light.ttf \
	fonts/OpenSans-LightItalic.ttf \
	fonts/OpenSans-Regular.ttf \
	fonts/OpenSans-Italic.ttf \
	fonts/OpenSans-Semibold.ttf \
	fonts/OpenSans-SemiboldItalic.ttf

TEMPLATES_TMPL=titlepage.templates.tmpl

TEMPLATES_XSL=$(TEMPLATES_TMPL:.tmpl=.xsl)

PDF_CONFIG_FILES=$(FOP_STYLE) $(COMMON_STYLE) $(FOP_XCONF) $(TEMPLATES_XSL)
HTML_CONFIG_FILES=$(HTML_STYLE) $(COMMON_STYLE) $(TEMPLATES_XSL)

DOC=$(HTML) $(HTML_REVHISTORY) $(PDF) $(IMAGES) $(STYLESHEET)

.SUFFIXES: .tmpl .xsl .inc .txt .raw .pdf .html

.txt.raw:
	sed -e 's/^[ 	]*//' -e 's/^\\//' $*.txt > $@

.inc.raw:
	sed -e 's/^[ 	]*//' -e 's/^\\//' $*.inc > $@

.raw.pdf:
	a2x --verbose -a docinfo -f pdf --xsltproc-opts "--stringparam toc.section.depth 2" --xsl-file $(FOP_STYLE) --fop --fop-opts="-c $(FOP_XCONF)" $*.raw
	a2x --verbose -a docinfo -f xhtml --xsltproc-opts "--stringparam toc.section.depth 2" --xsl-file $(HTML_STYLE) --stylesheet=$(STYLESHEET) $*.raw

.pdf.html:
	@touch $@

.tmpl.xsl:
	xsltproc --output $@ /usr/share/xml/docbook/stylesheet/docbook-xsl/template/titlepage.xsl $*.tmpl

all:	$(HTML) $(PDF)

altusmetrum-revhistory.html: altusmetrum.html

micropeak-revhistory.html: micropeak.html

telegps-revhistory.html: telegps.html

altusmetrum.pdf altusmetrum.html: altusmetrum-docinfo.xml $(RAW_FILES) $(IMAGES)

telegps.html telegps.pdf: telegps-docinfo.xml $(TELEGPS_RAW_FILES) $(IMAGES)

micropeak.pdf micropeak.html: micropeak-docinfo.xml $(MICROPEAK_RAW_FILES) $(IMAGES)

easymini.pdf easymini.html: easymini-docinfo.xml $(EASYMINI_RAW_FILES) $(IMAGES)

install:	all

publish:	$(DOC) $(FONTS)
	cp $(DOC) /home/bdale/web/altusmetrum/AltOS/doc/
	mkdir -p /home/bdale/web/altusmetrum/AltOS/doc/fonts/
	cp $(FONTS) /home/bdale/web/altusmetrum/AltOS/doc/fonts/
	(cd /home/bdale/web/altusmetrum ; \
	 git add /home/bdale/web/altusmetrum/AltOS/doc/* ; \
	 git add /home/bdale/web/altusmetrum/AltOS/doc/fonts/* ; \
	 echo "update docs" | \
	 git commit -F - /home/bdale/web/altusmetrum/AltOS/doc/* /home/bdale/web/altusmetrum/AltOS/doc/fonts/* ; \
	 git push)

publish-keithp:	am.html $(DOC) $(FONTS)
	scp -p am.html $(DOC) keithp.com:~keithp/public_html/altos
	scp -p $(FONTS) keithp.com:~keithp/public_html/altos/fonts

clean:
	rm -f am.html $(HTML) $(HTML_REVHISTORY) $(PDF) $(TEMPLATES_XSL) $(RAW_FILES) $(TELEGPS_RAW_FILES) $(MICROPEAK_RAW_FILES)

distclean: clean
	rm -f $(HTML) $(PDF)

$(PDF): $(PDF_CONFIG_FILES)
$(HTML): $(HTML_CONFIG_FILES)

am.html: Makefile make-am-html $(HTML)
	sh ./make-am-html $(HTML) > $@

=== src/Makefile ===
#
# AltOS build
#

vpath make-altitude util
vpath make-altitude-pa util
vpath make-kalman util
vpath make-whiten util
vpath kalman.5c kalman
vpath kalman_filter.5c kalman
vpath kalman_micro.5c kalman
vpath load_csv.5c kalman
vpath matrix.5c kalman

include Version
TOPDIR=.
include Makedefs

SDCCDIRS=\
	telemetrum-v1.2 telemetrum-v1.1 telemetrum-v1.0 \
	teledongle-v0.2 \
	telemini-v1.0 telemini-v2.0 \
	telebt-v1.0 \
	teleterra-v0.2 teleshield-v0.1 \
	telefire-v0.1 telefire-v0.2 \
	telerepeat-v1.0

ARMM3DIRS=\
	easymega-v1.0 easymega-v1.0/flash-loader \
	telemega-v0.1 telemega-v0.1/flash-loader \
	telemega-v1.0 telemega-v1.0/flash-loader \
	telemega-v2.0 telemega-v2.0/flash-loader \
	telemetrum-v2.0 telemetrum-v2.0/flash-loader \
	megadongle-v0.1 megadongle-v0.1/flash-loader \
	telegps-v0.3 telegps-v0.3/flash-loader \
	telegps-v1.0 telegps-v1.0/flash-loader \
	telelco-v0.2 telelco-v0.2/flash-loader \
	telelco-v0.3 telelco-v0.3/flash-loader \
	telescience-v0.2 telescience-v0.2/flash-loader \
	teledongle-v3.0 teledongle-v3.0/flash-loader \
	teleballoon-v2.0 \
	telebt-v3.0 telebt-v3.0/flash-loader \
	telelcotwo-v0.1 telelcotwo-v0.1/flash-loader \
	telefiretwo-v0.1 telefiretwo-v0.1/flash-loader \

ARMM0DIRS=\
	easymini-v1.0 easymini-v1.0/flash-loader \
	chaoskey-v0.1 chaoskey-v0.1/flash-loader \
	chaoskey-v1.0 chaoskey-v1.0/flash-loader

AVRDIRS=\
	telescience-v0.1 telescience-pwm micropeak nanopeak-v0.1 microkite

SUBDIRS=

ifeq ($(strip $(HAVE_PDCLIB)),yes)
PDCLIB=pdclib
CLEAN_PDCLIB=clean-pdclib
endif

ifeq ($(strip $(HAVE_SDCC)),yes)
SUBDIRS+=$(SDCCDIRS)
endif

ifeq ($(strip $(HAVE_ARM_M3_CC)),yes)
SUBDIRS+=$(ARMM3DIRS)
foo=bar
endif

ifeq ($(strip $(HAVE_ARM_M0_CC)),yes)
SUBDIRS+=$(ARMM0DIRS)
baz=bletch
endif

ifeq ($(strip $(HAVE_AVR_CC)),yes)
SUBDIRS += $(AVRDIRS)
endif

ALLDIRS=$(SDCCDIRS) $(ARMM3DIRS) $(ARMM0DIRS) $(AVRDIRS)

all: all-local all-recursive

RECURSIVE_TARGETS = all-recursive install-recursive

$(RECURSIVE_TARGETS):
	@target=`echo $@ | sed 's/-recursive//'`; \
	for subdir in $(SUBDIRS); do \
		echo "Making $$target in $$subdir"; \
		(cd $$subdir && $(MAKE) $$target) || exit 1; \
	done

ALL_RECURSIVE_TARGETS = clean-recursive

$(ALL_RECURSIVE_TARGETS):
	@target=`echo $@ | sed 's/-recursive//'`; \
	for subdir in $(ALLDIRS); do \
		echo "Making $$target in $$subdir"; \
		(cd $$subdir && $(MAKE) $$target) || exit 1; \
	done

distclean:	clean

clean: clean-local clean-recursive

install: install-recursive

uninstall:

all-recursive: all-local

all-local: altitude.h altitude-pa.h altitude-pa-small.h ao_kalman.h ao_whiten.h $(PDCLIB)

altitude.h: make-altitude
	nickle $< > $@

altitude-pa.h: make-altitude-pa
	nickle $< > $@

altitude-pa-small.h: make-altitude-pa
	nickle $< --sample 3 > $@

ao_kalman.h: make-kalman kalman.5c kalman_micro.5c kalman_filter.5c load_csv.5c matrix.5c
	bash $< kalman > $@

ao_whiten.h: make-whiten
	nickle $< > $@

clean-local: $(CLEAN_PDCLIB)
	rm -f altitude.h ao_kalman.h

pdclib:
	mkdir -p $(PDCLIB_ROOT)/include $(PDCLIB_ROOT)/lib 
	cd ../pdclib && make && make prefix=`pwd`/../pdclib-root install

clean-pdclib:
	rm -rf $(PDCLIB_ROOT)
	cd ../pdclib && make clean

=== debian/changelog ===
altos (1.6.5-1) unstable; urgency=medium

  [ Keith Packard ]
  * doc: Add install-html script
  * Bump android version to 13
  * ao-tools/ao-chaosread: Document length (-l) option
  * altosdroid: Deal with multiple installed android SDKs
  * Mark testing version 1.6.4.1
  * altosui: Deliver firmware for Tmega 2.0 and TBT 3.0 for Windows too
  * altos: Block interrupts while waking tasks sleeping on timers.
  * altos: Move comment in ao_sleep_for next to related code
  * altos/stm: remove ao_dma_abort
  * altos/stm: use 0xff for dma mutex value for allocated mutexes
  * altos/stm: Add more SPI status register bits
  * altos/stm: Change ao_spi_send_sync definition to take const source
  * altos: Add STM DMA debugging
  * altos: Add STM SPI debugging
  * altos/stm: move spi execution to common ao_spi_run
  * altos/stm: Clean up spi_enable/disable_index functions
  * altos/stm: Add better byte-level SPI api
  * altos/drivers: Use more reliable byte interface for CC1120 reception
  * altos: Add debug check for irq block when editing task queues
  * altos: cc1200: use FIFO threshold pin output for APRS buffering
  * altos: Make ao_delay(0) not wait forever
  * altos/telemini-v2.0: Remove show tasks command
  * altos: Make task list output more useful
  * altos/stm: clean up ao_exti_enable
  * altos: Leave USB enabled in flight with -DDEBUG=1
  * altos: Use FIFO_THR pin for cc1120 transmit buffering
  * Bump to testing version 1.6.4.2
  * altos/cc1111: Remove 'show tasks' command
  * Bump to 1.6.5. Add preliminary release notes
  * Credit Chuck Haskin for helping fix the SPI bug.
  * doc: Build 1.6.5 release notes

  [ Bdale Garbee ]
  * switch libgtk-3-bin build-dep to gtk-update-icon-cache, closes: #825455
  * updating ChangeLog for 1.6.5 release

 -- Bdale Garbee <bdale@gag.com>  Mon, 04 Jul 2016 23:48:50 +0200

altos (1.6.4-1) unstable; urgency=medium

  [ Keith Packard ]
  * altos/cc1111: Use SW to drive UART RTS pin
  * Bump version to 1.6.3.1
  * altosui/telegps: Ship firmware for new hardware
  * altosdroid: Check for closed before writing/reading bluetooth
  * Publish firmware with keithp-fat
  * Add TeleMega to spec list. Add TeleGPS RF output.
  * altoslib: Switch distance from m/ft to km/miles for large values
  * altoslib: Remove some debug printf calls
  * altosuilib: Rate limit map loading pacifier updates
  * altoslib: Allow map preloading to be aborted
  * altosdroid: Rate limit map loading pacifier
  * altosuilib: Don't flicker missing voltages when changing units
  * doc: Start update for 1.6.4
  * altoslib: Clean up map file and url handling
  * altosdroid: make disconnect stick past pause/restart
  * altoslib: Get rid of AltosMap from AltosMapLoader
  * telegps: Adapt to distance units switching changes
  * Bump android app version
  * Bump java library versions
  * Automatically run 'git submodule update' if necessary
  * altosui/telegps/micropeak: Handle both MULTI_LIB and non-MULTI_LIB builds
  * altoslib: Store common frequencies in library version-independent form
  * altoslib: Store saved state in version-independent format
  * altoslib: Allow empty values in AltosHashSet representation
  * altoslib: Set version and log space from AltosIdleFetch
  * altoslib: Add log_space to AltosState
  * altoslib: Add AltosIdleReader
  * telegps: Use log_space when flight_log_max is missing
  * telegps: Add monitor idle mode
  * altoslib: use miles for distances > 1000ft.
  * altosuilib: Have map preload respond to units and font size changes
  * altosuilib: Rename AltosUIMap*New.java to AltosUIMap*.java
  * doc: pad/idle indicator table was busted
  * altosuilib: Fill preload map on site or lat/lon change
  * altosuilib: Only display map debugging when serial_debug is enabled
  * telegps-v1.0: Document how SN 1959 was fixed
  * stmf0: Clear all USB state when resetting chip. Wakeup all sleepers
  * stmf0: Do not send more data than requested for GET_DESCRIPTOR
  * altos/lpc: Handle USB reset by resetting internal state
  * altos/stm: Handle USB reset in STM32L usb driver
  * altos/cc1115l: Reduce trace buffer size
  * altos/stmf0: Rework the sram allocation to save a few text bytes
  * altos/stmf0: Remove ao_usb_free
  * altosdroid: Auto save freq changes on 'ok'
  * altosui: Remove missing items from --summary output
  * altosuilib: Track open frames, exit when none remain
  * altosui: Don't open command window when --graph is provided
  * doc: Updates to 1.6.4 release notes.
  * altoslib: Switch preserved state format to JSON
  * altoslib: Remove AltosHashSet code
  * altoslib: Add null constructors to AltosQuaternion and AltosRotation
  * altoslib: Add JSON-based object saving/restoring code
  * altoslib: Use reflection JSON code for frequency preferences
  * altoslib: Improve AltosState save/restore debugging
  * altoslib: Get rid of manual JSON encoding stuff
  * altoslib: Add null constructor for AltosCompanion
  * altoslib: Add construction for remaining primitive array types to JSON
  * altoslib: Add back some JSON exception debugging printfs
  * altosui: Print filename before attempting to parse in --summary mode
  * altoslib: Stop reflective JSON class walk at Object instead of null
  * Bump version to 1.6.4

  [ Bdale Garbee ]
  * process updates made during 1.6.3 release cycle
  * extend "ok" temp range to 40C, since battery charger on bench can drive temp above 35C at times in Bdale and Robert's production testing
  * releasing 1.6.4

 -- Bdale Garbee <bdale@gag.com>  Fri, 17 Jun 2016 10:02:32 -0600

altos (1.6.3-1) unstable; urgency=medium

  [ Keith Packard ]
  * Releasing: Copy TeleMega v2.0 bits to Binaries
  * src/chaoskey-v0.1: Add HV enable support
  * altos/chaoskey: Add support for flipping between raw and cooked bits
  * altos/chaoskey: Delay ADC reading for 250ms at startup
  * altos: remove blank line in stmf0/ao_timer.c
  * altos/stmf0: Allow projects to specify non-default stack size
  * altos: Add power management APIs


=== debian/control ===
Source: altos
Section: electronics
Priority: optional
Maintainer: Bdale Garbee <bdale@gag.com>
Uploaders: Keith Packard <keithp@keithp.com>
Build-Depends: asciidoc,
               autoconf,
               automake,
               cc1111,
               debhelper (>= 7),
               default-jdk,
               docbook-xml,
               docbook-xsl,
               fop,
               freetts,
               gawk,
               gcc-arm-none-eabi,
               graphicsmagick | imagemagick,
               icnsutils,
               icoutils,
               libbluetooth-dev,
               libelf-dev,
               gtk-update-icon-cache,
               libjfreechart-java,
               libreadline-dev,
               librsvg2-bin,
               libssl-dev,
               libtool,
               libusb-1.0-0-dev,
               netpbm,
               nickle,
               pkg-config,
               shared-mime-info,
               swig,
               xmlto,
               xsltproc
Standards-Version: 3.9.5
Homepage: http://altusmetrum.org/AltOS
Vcs-Git: git://git.gag.com/fw/altos -b debian
Vcs-Browser: http://git.gag.com/?p=fw/altos

Package: altos
Architecture: any
Depends: default-jre | java2-runtime,
         freetts,
         libjfreechart-java,
         nickle,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: slim | gdm
Replaces: altusmetrum-themes, slim-altusmetrum
Conflicts: altusmetrum-themes, slim-altusmetrum
Description: Altus Metrum firmware and utilities
 Firmware and utilities needed to support high power model rocketry products
 from Altus Metrum, including TeleMetrum, TeleMini, and TeleDongle.
 .
 See http://altusmetrum.org/ for more information.

## altos 1.6.8

=== doc/Makefile ===
--- 
+++ 
@@ -3,6 +3,7 @@
 #
 
 RELNOTES_INC=\
+	release-notes-1.6.8.inc \
 	release-notes-1.6.5.inc \
 	release-notes-1.6.4.inc \
 	release-notes-1.6.3.inc \

=== pdclib/Makefile ===
# $Id$

ifndef prefix
prefix=/opt/cortex
endif

libdir=$(prefix)/lib
bindir=$(prefix)/bin
includedir=$(prefix)/include

#CPU=cortex-m3
CPUS=cortex-m0 cortex-m3 cortex-m4
FIRSTCPU=cortex-m0
CPU=none
BUILD=build-$(CPU)

# CPU specific compiler flags
ifeq ($(CPU),cortex-m0)
CPU_FLAGS=
endif
ifeq ($(CPU),cortex-m3)
CPU_FLAGS=
endif
ifeq ($(CPU),cortex-m4)
CPU_FLAGS=-mfloat-abi=hard
endif

#CC=$(bindir)/arm-none-eabi-gcc
CC=/usr/bin/arm-none-eabi-gcc

# This is where you chose which platform to compile for (see 'make links' / './platform')
PLATFORM := altos

# This is a list of all non-source files that are part of the distribution.
AUXFILES := Makefile Readme.txt

# Directories belonging to the project
PROJDIRS := functions includes internals
# All source files of the project
SRCFILES := $(shell find -L $(PROJDIRS) -type f -name "*.c")
BUILDFILES := $(shell find -L $(BUILD) -type f -name "*.c")
# All header files of the project
HDRFILES := $(shell find -L $(PROJDIRS) -type f -name "*.h")
BUILDHDRFILES := $(shell find -L $(BUILD) -type f -name "*.h")
# All .c files in functions/_PDCLIB that do not have a regression test driver
INTFILES := _Exit atomax digits open print scan remove rename seed stdinit strtox_main strtox_prelim filemode eol errno seek prepread prepwrite allocpages tmpfilename closeall
# All object files in the library
OBJFILES := $(patsubst %.c,%.o,$(BUILDFILES))
# All test drivers (.t)
TSTFILES := $(patsubst %.c,%_t,$(SRCFILES))
# All regression test drivers (.r)
REGFILES := $(filter-out $(patsubst %,functions/_PDCLIB/%_r,$(INTFILES)),$(patsubst %.c,%_r,$(SRCFILES)))
# All library dependency files (.d)
DEPFILES := $(patsubst %.c,%.d,$(SRCFILES))
# All test driver dependency files (_t.d)
TSTDEPFILES := $(patsubst %,%.d,$(TSTFILES))
# All regression test driver dependency files (_r.d)
REGDEPFILES := $(patsubst %,%.d,$(REGFILES))
# All files belonging to the source distribution
ALLFILES := $(SRCFILES) $(HDRFILES) $(AUXFILES)

WARNINGS := -Wall -Wextra -pedantic -Wno-unused-parameter -Wshadow -Wpointer-arith -Wcast-align -Wwrite-strings -Wmissing-prototypes -Wmissing-declarations -Wredundant-decls -Wnested-externs -Winline -Wno-long-long -Wuninitialized -Wstrict-prototypes 
PLATFORM_FLAGS=-mlittle-endian -mthumb -mcpu=$(CPU) -ffreestanding $(CPU_FLAGS)
CFLAGS := -Os -g -std=c99 -I./$(BUILD)/internals -I./testing $(WARNINGS) $(USERFLAGS) $(PLATFORM_FLAGS)

.PHONY: all clean srcdist bindist test tests testdrivers regtests regtestdrivers todos fixmes find links unlink help

PDCLIBNAME=libpdclib
PDCLIB=$(PDCLIBNAME)-$(CPU).a

all:
	+for i in $(CPUS); do make CPU=$$i links; make CPU=$$i $(PDCLIBNAME)-$$i.a; done

install: install-hdr
	@echo '######' install
	+for i in $(CPUS); do make CPU=$$i prefix=$(prefix) install-lib-$$i; done

install-hdr:
	@echo '######' install-hdr
	+make CPU=$(FIRSTCPU) prefix=$(prefix) install-hdr-$(FIRSTCPU)

clean:
	+for i in $(CPUS); do make CPU=$$i clean-$$i; rm -rf build-$$i; done

check: all testdrivers regtestdrivers
	@echo
	@echo "========================"
	@echo "Executing library tests:"
	@echo "========================"
	@echo
	@$(MAKE) tests | grep -v "^ TST" | grep -v "^Failed"
	@echo
	@echo "==========================="
	@echo "Executing regression tests:"
	@echo "==========================="
	@echo
	@$(MAKE) regtests | grep -v "^ RTST" | grep -v "^Failed"

$(PDCLIB): $(BUILD) $(OBJFILES)
	@echo " AR	$@"
	@ar rc $@ $(OBJFILES)
	@echo

install-$(CPU): install-$(CPU)-lib install-hdr
	@echo '######' install-$(CPU)

install-lib-$(CPU): $(PDCLIB)
	@echo '######' install-lib-$(CPU)
	install -D -c $(PDCLIB) $(DESTDIR)$(libdir)/$(PDCLIB)

install-hdr-$(CPU): $(BUILD) $(BUILDHDRFILES)
	@echo '######' install-hdr-$(CPU)
	for file in $(BUILDHDRFILES); do \
		install -m 0444 -D -c $$file $(DESTDIR)$(includedir)/.; \
	done

test: functions/$(FILE)
	functions/$(FILE)

tests: testdrivers
	-@rc=0; count=0; failed=""; for file in $(TSTFILES); do echo " TST	$$file"; ./$$file; test=$$?; if [ $$test != 0 ]; then rc=`expr $$rc + $$test`; failed="$$failed $$file"; fi; count=`expr $$count + 1`; done; echo; echo "Tests executed (linking PDCLib): $$count  Tests failed: $$rc"; echo; for file in $$failed; do echo "Failed: $$file"; done; echo

testdrivers: $(TSTFILES)
	@echo

regtests: regtestdrivers
	-@rc=0; count=0; failed=""; for file in $(REGFILES); do echo " RTST	$$file"; ./$$file; test=$$?; if [ $$test != 0 ]; then rc=`expr $$rc + $$test`; failed="$$failed $$file"; fi; count=`expr $$count + 1`; done; echo; echo "Tests executed (linking system libc): $$count  Tests failed: $$rc"; echo; for file in $$failed; do echo "Failed: $$file"; done; echo

regtestdrivers: $(REGFILES)
	@echo

-include $(DEPFILES) $(TSTDEPFILES) $(REGDEPFILES)

clean-$(CPU): $(BUILD)
	-@$(RM) $(wildcard $(OBJFILES) $(DEPFILES) $(TSTFILES) $(TSTDEPFILES) $(REGFILES) $(REGDEPFILES) $(PDCLIB) pdclib.tgz scanf_testdata_*)

srcdist:
	@tar czf pdclib.tgz $(ALLFILES)

todos:
	-@for file in $(ALLFILES:Makefile=); do grep -H TODO $$file; done; true

fixmes:
	-@for file in $(ALLFILES:Makefile=); do grep -H FIXME $$file; done; true

find:
	@find functions/ includes/ internals/ platform/ -name "*\.[ch]" -type f | xargs grep $$FIND

links: $(BUILD)
	@echo "Linking platform/$(PLATFORM)..."
	@for dir in $$(find functions includes internals -type d); do mkdir -p $(BUILD)/$$dir; done
	@for file in $$(find platform/$(PLATFORM) -mindepth 2 -type f ! -path *.svn* -printf "%P\n"); do if [ ! -f $(BUILD)/$$file ]; then ln -s $$(dirname $$file | sed "s@[^/]*@..@g")/../platform/$(PLATFORM)/$$file $(BUILD)/$$file; fi; done
	@for super in $(PROJDIRS); do for file in $$(find $$super -type f ! -path *.svn* -printf "%P\n"); do if [ ! -f $(BUILD)/$$super/$$file ]; then ln -s $$(echo $$file | sed "s@[^/]*@..@g")/../$$super/$$file $(BUILD)/$$super/$$file; fi; done; done
	if [ -f platform/$(PLATFORM)/include-exclude ]; then for ex in `cat platform/$(PLATFORM)/include-exclude`; do echo exclude $$ex; rm -f $(BUILD)/includes/$$ex; done; fi; true

unlink: $(BUILD)
	@echo "Unlinking platform files..."
	@for dir in $(PROJDIRS); do find $(BUILD)/$$dir -type l -exec rm {} +; done

help:
	@echo "Available make targets:"
	@echo
	@echo "all              - build $(PDCLIB)"
	@echo "clean            - remove all object files, dependency files and test drivers"
	@echo "srcdist          - build pdclib.tgz (source tarball)"
	@echo "test             - test a single testdriver (Usage: FILE=\"test.[rt]\" make test)"
	@echo "tests            - build and run test drivers (link $(PDCLIB))"
	@echo "  testdrivers    - build but do not run test drivers"
	@echo "regtests         - build and run regression test drivers (link system clib)"
	@echo "  regtestdrivers - build but do not run regression test drivers"
	@echo "todos            - list all TODO comments in the sources"
	@echo "fixmes           - list all FIXME comments in the sources"
	@echo "find             - find a phrase in the sources (Usage: FIND=\"phrase\" make find)"
	@echo "links            - link platform files (development only)"
	@echo "unlink           - remove links to platform files (development only)"
	@echo "%.o              - build an individual object file"
	@echo "%.t              - build an individual test driver"
	@echo "%.r              - build an individual regression test driver"
	@echo "help             - print this list"
	@echo
	@echo "Any additional compiler flags you want to use can be passed as USERFLAGS"
	@echo "(Usage: USERFLAGS=\"flags\" make [...])."

%.o: %.c Makefile
	@echo " CC	$(patsubst functions/%,%,$@)"
	@$(CC) $(CFLAGS) -MMD -MP -I./$(BUILD)/includes -c $< -o $@

%_t: %.c Makefile $(PDCLIB)
	@echo " CC	$(patsubst functions/%,%,$@)"
	@$(CC) $(CFLAGS) -MMD -MP -DTEST -I./$(BUILD)/includes $< $(PDCLIB) -o $@

%_r: %.c Makefile
	@echo " CC	$(patsubst functions/%,%,$@)"
	@$(CC) $(CFLAGS) -MMD -MP -DTEST -DREGTEST $< -o $@

$(BUILD):
	mkdir -p $(BUILD)

=== src/Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
 SDCCDIRS=\
 	telemetrum-v1.2 telemetrum-v1.1 telemetrum-v1.0 \
 	teledongle-v0.2 \
-	telemini-v1.0 telemini-v2.0 \
+	telemini-v1.0 \
 	telebt-v1.0 \
 	teleterra-v0.2 teleshield-v0.1 \
 	telefire-v0.1 telefire-v0.2 \
@@ -31,6 +31,7 @@
 	telemega-v1.0 telemega-v1.0/flash-loader \
 	telemega-v2.0 telemega-v2.0/flash-loader \
 	telemetrum-v2.0 telemetrum-v2.0/flash-loader \
+	telemetrum-v3.0 telemetrum-v3.0/flash-loader \
 	megadongle-v0.1 megadongle-v0.1/flash-loader \
 	telegps-v0.3 telegps-v0.3/flash-loader \
 	telegps-v1.0 telegps-v1.0/flash-loader \

=== src/chaoskey-v1.0/Makefile ===
#
# AltOS build
#
#

include ../stmf0/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pins.h \
	ao_product.h \
	ao_task.h \
	ao_adc_fast.h \
	ao_power.h \
	stm32f0.h

#
# Common AltOS sources
#
ALTOS_SRC = \
	ao_interrupt.c \
	ao_timer.c \
	ao_panic.c \
	ao_mutex.c \
	ao_dma_stm.c \
	ao_adc_fast.c \
	ao_crc_stm.c \
	ao_stdio.c \
	ao_led.c \
	ao_romconfig.c \
	ao_boot_chain.c \
	ao_usb_stm.c \
	ao_trng_send.c \
	ao_task.c \
	ao_power.c \
	ao_gpio.c \
	ao_product.c

PRODUCT=ChaosKey-hw-1.0-sw-$(VERSION)
PRODUCT_DEF=-DCHAOSKEY_V_1_0
IDVENDOR=0x1d50
IDPRODUCT=0x60c6

CFLAGS = $(PRODUCT_DEF) $(STMF0_CFLAGS) -g -Os

PROGNAME=chaoskey-v1.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_chaoskey.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -V $(IDVENDOR) -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) -o $@

$(OBJ): $(INC)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h

install:

uninstall:

=== debian/changelog ===
altos (1.6.8-5) unstable; urgency=medium

  [ Keith Packard ]
  * altos/lpc,altos/stmf0: Use -n flag to work around link editor issue,
    closes: #860601
  * ao-elftohex: Add conditions for skipping ELF sections
  * ao-tools/ao-flash-lpc: Adapt to current openocd LPC support
  * altos/telegps: Inherit LDFLAGS from lpc make specification

 -- Bdale Garbee <bdale@gag.com>  Sat, 22 Apr 2017 12:07:57 -0600

altos (1.6.8-4) unstable; urgency=medium

  [ Keith Packard ]
  * altos/arm: Align data so that gcc 5.4 doesn't do byte-accesses. Add -Wcast-align

 -- Bdale Garbee <bdale@gag.com>  Wed, 25 Jan 2017 12:22:30 -0700

altos (1.6.8-3) unstable; urgency=medium

  [ Keith Packard ]
  * altos/stm: Make ao_usb_set_address static. Saves a bunch of text space,
    closes: #844816

 -- Bdale Garbee <bdale@gag.com>  Tue, 13 Dec 2016 00:19:44 -0700

altos (1.6.8-2) unstable; urgency=medium

  [ Keith Packard ]
  * Update pdclib to version using arm-specific 'ar' program, closes: #838357

 -- Bdale Garbee <bdale@gag.com>  Sun, 02 Oct 2016 17:49:32 -0600

altos (1.6.8-1) unstable; urgency=medium

  [ Bdale Garbee ]
  * updates made during 1.6.5 release process
  * remove debian/ from master branch, it should live only on the debian branch
  * reinstate debian/ content on the debian branch only
  * update to latest Debian standards version
  * update Changelog for release

  [ Keith Packard ]
  * Switch from GPLv2 to GPLv2+
  * altos: Add telemetrum v3.0
  * Bump version to 1.6.5.1 after 1.6.5 release
  * altosuilib: Show indicator when they switch from invalid back to valid
  * altos: Add STM32F0 beep and SPI byte API.
  * altos: Keep telemetry and command output from interleaving
  * altos: Don't access cc1120 SPI bus during recv after abort has started
  * fixup for interleave
  * altos: Expose cc1200 radio test functions for telemini bringup
  * altos: Don't switch to flight 0 when log fills in flight
  * altos: Stop building cc1111-based telemini v2.0 firmware
  * altoslib: Add a 'seconds' method to AltosGPS
  * altos: Add 'ao_button_get' to button driver
  * altos: Make telelcotwo control two boxes instead of two pads
  * altos/stmf0: Hook up clock output support
  * altos/stmf0: Clean .bin files from flash-loader dirs
  * altos: Use standard FIPS testing for chaoskey
  * ao-chaosread: Add --infinite and --bytes options
  * ao-chaosread: Eliminate double-free when serial match fails
  * ao-bringup: Test chaoskey using dieharder
  * ao-bringup: Use released files for chaoskey turnon
  * Bump to version 1.6.6
  * ao-bringup: Add colors to chaoskey test result reporting
  * altos: Flash all LEDS during power on
  * altos/stmf0: Switch ADC fast to ADC clock
  * Bump verison to 1.6.7
  * ao-chaosread: Parse -i and -b options
  * ao-usbload: Check target device name to avoid mis-flashing
  * altos/cc1120: remove unused status from ao_radio_fifo_write_stop
  * ao-bringup: telemega allow serial on command line, loop on accel fail
  * ao-tools/ao-cal-freq: --verbose option has no parameter
  * altosui: Deal with connect failure in AltosConfigTD
  * ao-bringup/turnon_telemetrum: serial on cmd line. Loop on accel fail
  * ao-tools/ao-usbload: Fix -f flag, remove debug hacks
  * ao-tools/ao-cal-freq: Re-open usb device each try
  * Bump version to 1.6.7.1
  * altos/stm: Make ao_spi_duplex out pointer const
  * altos/stm: Create funcs to set SPI DMA parameters
  * altos/stm: Set MISO DMA priority to HIGH to avoid OVR
  * altos/stm: Set i2c recv DMA to HIGH
  * altos/stm: Set SPI slave DMA priority to HIGH/VERY_HIGH
  * Add 1.6.8 release notes
  * altosui: Don't ship TeleMetrum v3.0 firmware (yet)
  * Bump version to 1.6.8
  * Remove pyro wizard file from master

 -- Bdale Garbee <bdale@gag.com>  Mon, 05 Sep 2016 21:02:09 -0600

=== debian/control ===
--- 
+++ 
@@ -34,7 +34,7 @@
                swig,
                xmlto,
                xsltproc
-Standards-Version: 3.9.5
+Standards-Version: 3.9.8
 Homepage: http://altusmetrum.org/AltOS
 Vcs-Git: git://git.gag.com/fw/altos -b debian
 Vcs-Browser: http://git.gag.com/?p=fw/altos
